#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<curses.h>
#include<limits.h>
#include<float.h>

#define fors__ubn 10000

#define index__ubn(x) ((x)<-0.5 || (x)>=INT_MAX+0.5 ?\
ierr__ubn("index overflow", line__ubn) : (int)((x)+0.5))

#define round__ubn(x) ((x)<INT_MIN-0.5 || (x)>=INT_MAX+0.5 ? ierr__ubn(\
"integer overflow", line__ubn) : ((x)>=0?(int)((x)+0.5):(int)((x)-0.5)))

char return__ubn[fors__ubn];
char *returnP__ubn;
char fora__ubn[fors__ubn];
char for__ubn[fors__ubn];
char *forP__ubn;
char *tempP__ubn;
int switcher__ubn;
int line__ubn;
int forvar__ubn;
int back__ubn;
float to__ubn[fors__ubn];
float step__ubn[fors__ubn];
float sf__ubn=0.0000001;
int datac__ubn;
int fuzz__ubn;
float big__ubn;
int i__ubn;
float f__ubn;
int P__ubn;
char phrase__ubn[300];
float dend__ubn;

char chrs__ubn[256][2];

FILE *bug;
char tron=0;
FILE *file__ubn[10];
int eof__ubn[10];

typedef struct string__ubn { char dummy__ubn[300]; } empty__ubn;

int asc__ubn(char *string) {
  return string[0];
}

char *chr__ubn(int val) {
  return chrs__ubn[val];
}

int len__ubn(char *name) {
  int i = 0;
  while (name[i]) i++;
  return i;
}

void error__ubn(char *mesg, int line) {
  printf("%s in line %d", mesg, line);
  exit(0);
}

int ierr__ubn(char *mesg, int line) {
  error__ubn(mesg, line__ubn);
  return 0;
}

char *join__ubn(int linenumber, char *first, char *second) {
  char *toP;
  char *retval;
  char *firstP = first;
  char *secondP = second;
  int i = 0;
  char *mesg;
  toP = malloc(sizeof(struct string__ubn));
  retval = toP;
  mesg = "";
  if (first==second)  mesg = "string order";
  while ((*toP++ = *firstP++))  i++;
  while ((*toP++ = *secondP++))  if (i++>256)  break;
  if (i>256) {
    if (!mesg[0])  mesg = "string overflow";
    printf("%d %s %s\n%s", linenumber, mesg, first, second);
    exit(0);
  }
  return retval;
}

char *let__ubn(char *toP, char *fromP) {
  char *retval;
  retval = toP;
  while ((*toP++=*fromP++));
  *toP = 0;
  return retval;
}

char *mid__ubn(char *fromP, int begin, int length) {
  char *toP;
  char *retval;
  toP = malloc(sizeof(struct string__ubn));
  retval = toP;
  if (length>strlen(fromP)||!length) length=strlen(fromP);
  if (begin>strlen(fromP)+1)  begin=strlen(fromP)+1;
  fromP = fromP+begin-1;
  while (length--&&*fromP)  *toP++=*fromP++;
  *toP = 0;
  return retval;
}

void lineinput__ubn(int fileno, char *lineP) {
  if (fileno<0 || fileno>9)  error__ubn("bad file number", line__ubn);
  if (eof__ubn[fileno]==EOF)  error__ubn("input past end", line__ubn);
  eof__ubn[fileno] = fgetc(file__ubn[fileno]);
  while (eof__ubn[fileno] && eof__ubn[fileno]!=EOF
      && eof__ubn[fileno]!=10) {
    *lineP++=eof__ubn[fileno];
    eof__ubn[fileno] = fgetc(file__ubn[fileno]);
  }
  *lineP = 0;
}

char *left__ubn(char *fromP, int delta) {
  char *toP;
  int i;
  toP = malloc(sizeof(struct string__ubn));
  if (delta>strlen(fromP))  delta=strlen(fromP);
  for (i=0; i<delta; i++)  toP[i]=fromP[i];
  toP[i] = 0;
  return toP;
}

char *right__ubn(char *charP, int delta) {
  int start;
  start = strlen(charP)-delta;
  if (start<0)  start=0;
  return charP+start;
}

 instr__ubn(int start, char *target, char *arrow) {
  int i, j;
  if (start-1+strlen(arrow)>strlen(target))  return 0;
  for (j=start-1; j<=strlen(target)-strlen(arrow); j++) {
    i = 0;
    if (target[j]==arrow[0])
      for (i=0; i<strlen(arrow); i++)
        if (arrow[i]!=target[j+i])  break;
    if (i>=strlen(arrow))  break;
  }
  if (j>strlen(target)-strlen(arrow))  j=-1;
  return  j+1;
}

char *float__ubn(char *charP, double input) {
  char ch;
  char *tempP;
  char str[20];
  int i;
  int exp;
  int trunc;
  int digits;
  long dividend;
  long quotient;
  long divisor;
  float original;
  str[1] = 0;
  if (input<0)  strcpy(charP, "-");
  else strcpy(charP, " ");
  if (input<0) input=-input;
  exp = 0;
  while (input>=1.0) {
    exp++;
    input = input/10.0;
  }
  if (input>100.0*DBL_MIN) {
    while (input<0.1){
      exp--;
      input = input*10.0;
    }
    dividend = 1000000000.0*input+0.5;
  }
  else {dividend = 0; exp=1;}
  digits = 0;
  if (exp>-3 && exp<1) {
    strcat(charP, ".");
    for (i=0; i>exp; i--) strcat(charP, "0");
    digits=-1; exp=0;
  }
  else if (exp<10) {digits=exp; exp=0;}
  else {digits=1; exp--;}
  divisor = 100000000;
  do {
    if (!digits--) strcat(charP, ".");
    str[0] = dividend/divisor+'0';
    strcat(charP,str);
    dividend = dividend-dividend/divisor*divisor;
    divisor=divisor/10;
  }
  while (dividend>1 || digits>0);
  return charP;
  if (digits>9) {
    exp = digits-1;
    digits = 1;
  }
  else if (digits<-3) {
    exp = digits+1;
    digits = 1;
  }
  else exp=0;
  while (trunc-->0 || digits-->0) {
    if (!digits)  strcat(charP, ".");
    ch = (int)dividend/10.0;
    if (ch>9) ch=9;
    dividend = dividend-(float)ch;
    str[0] = ch+'0';
    strcat(charP, str);
  }
  if (exp) {
    tempP = str+20;
    *--tempP = 0;
    while (exp) {
      *--tempP =  exp-exp/10+'0';
      exp = exp/10;
    }
    *--tempP = 'E';
    strcat(charP, tempP);
  }
}


#define MAX 25.0

char LINE_s_ubn[index__ubn(MAX)][300];
char BASE_s_ubn[index__ubn(512.0)][300];
char COMMANDS_s_ubn[index__ubn(25.0)][300];
char LABEL_s_ubn[index__ubn(MAX)][300];
double LABEL_f_ubn[index__ubn(MAX)];
char COMMAND_s_ubn[index__ubn(MAX)][300];
double COMMAND_f_ubn[index__ubn(MAX)];
char TARGET_s_ubn[index__ubn(MAX)][300];
double TARGET_f_ubn[index__ubn(MAX)];
char SYMBOL_s_ubn[index__ubn(MAX)][300];
char ROBOTS_s_ubn[index__ubn(4.0)][300];
double SYMVAL_f_ubn[index__ubn(MAX)];
double STACK_f_ubn[index__ubn(100.0)];
double ARGC_f_ubn;
char NAME_s_ubn[300];
char ARGV_s_ubn[300];
double LINES_f_ubn;
char T_s_ubn[300];
double I_f_ubn;
double EAST_f_ubn;
double NORTH_f_ubn;
double WEST_f_ubn;
double SOUTH_f_ubn;
double COMMANDS_f_ubn;
double L_f_ubn;
double K_f_ubn;
double J_f_ubn;
double COMMANDER_f_ubn;
double SYMBOLS_f_ubn;
double SYMBOL_f_ubn;
double P_f_ubn;
char SIZE_s_ubn[300];
char UNDER_s_ubn[300];
double DIRECTION_f_ubn;
char ROBOT_s_ubn[300];
double TOP_f_ubn;

char *datav__ubn[] = {
  "WALK",
  "PICK UP",
  "PUT DOWN",
  "RETURN",
  "END",
  "GOSUB",
  "IF MARKED GOTO",
  "IF ZERO GOTO",
  "IF BLOCKED GOTO",
  "IF NOT MARKED GOTO",
  "IF NOT ZERO GOTO",
  "IF NOT BLOCKED GOTO",
  "GOTO",
  "/",
  "4",
  "5",
  ""
};

int main(int argc__ubn, char **ARGV_s_ubn) {
  float ARGC_f_ubn;
  ARGC_f_ubn = (float)argc__ubn;
  initscr();
  scrollok(stdscr, 1);
  printw("hello world\n");
  refresh(); getch();
  forP__ubn = for__ubn;
  returnP__ubn = return__ubn;
  datac__ubn = 0;
  for (i__ubn=0; i__ubn<256; i__ubn++) {
    chrs__ubn[i__ubn][0] = i__ubn;
    chrs__ubn[i__ubn][1] = 0;
  }
  if (tron)  fprintf(bug, "\n1 # CONSTANT MAX= 25") ;
  line__ubn = 1;


  if (tron)  fprintf(bug, "\n3  DIM LINE$(MAX)") ;
  line__ubn = 3;
  

  if (tron)  fprintf(bug, "\n5  IF ARGC<>2 THEN NAME$=\"ADD.BAS\" ELSE NAME$=ARGV$(1)") ;
  line__ubn = 5;
  if (fabs(fabs(ARGC_f_ubn)-fabs(2.0))>sf__ubn) {let__ubn(NAME_s_ubn, "ADD.BAS");}
  else {let__ubn(NAME_s_ubn, ARGV_s_ubn[index__ubn(1.0)]);}

  if (tron)  fprintf(bug, "\n7  OPEN\"I\",#1,NAME$") ;
  line__ubn = 7;
  file__ubn[index__ubn(1.0)] = fopen(NAME_s_ubn, "r");
  if (!file__ubn[index__ubn(1.0)])  error__ubn("bad name", line__ubn);

  if (tron)  fprintf(bug, "\n9  LINES=0") ;
  line__ubn = 9;
  LINES_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n10  LINE INPUT#1,T$") ;
  line__ubn = 10;
  lineinput__ubn(1.0, T_s_ubn);;
  if (tron)  fprintf(bug, "\n11  FOR I=0 TO 1 STEP 0") ;
  line__ubn = 11;
  I_f_ubn=0.0; *forP__ubn++=39; *returnP__ubn++=0;
  to__ubn[0]=(float)(1.0); step__ubn[0]=(float)(0.0); goto for__ubn0;
return0__ubn:
  I_f_ubn=I_f_ubn+step__ubn[0];
  if (step__ubn[0]>0 && I_f_ubn>to__ubn[0]) goto forgone__ubn;
  if (step__ubn[0]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[0]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[0]<0 && I_f_ubn<to__ubn[0]) goto forgone__ubn;
for__ubn0:
  if (tron)  fprintf(bug, "\n12  LINES=LINES+1") ;
  line__ubn = 12;
  LINES_f_ubn=LINES_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n13  LINE$(LINES)=T$") ;
  line__ubn = 13;
  let__ubn(LINE_s_ubn[index__ubn(LINES_f_ubn)], T_s_ubn);
  if (tron)  fprintf(bug, "\n14  LINE INPUT#1,T$") ;
  line__ubn = 14;
  lineinput__ubn(1.0, T_s_ubn);;
  if (tron)  fprintf(bug, "\n15  IF T$=\"/\" THEN I=1") ;
  line__ubn = 15;
  if (strcmp(T_s_ubn, "/")==0) {I_f_ubn=1.0;}
  if (tron)  fprintf(bug, "\n16  PRINT T$") ;
  line__ubn = 16;
  printw(T_s_ubn);
  printw("\n");
  refresh();
  if (tron)  fprintf(bug, "\n17  NEXT") ;
  line__ubn = 17;
  forvar__ubn=0; back__ubn=1; goto next__ubn;
return1__ubn:
  if (tron)  fprintf(bug, "\n18  LINES=LINES+1") ;
  line__ubn = 18;
  LINES_f_ubn=LINES_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n19  LINE$(LINES)=\"! END\"") ;
  line__ubn = 19;
  let__ubn(LINE_s_ubn[index__ubn(LINES_f_ubn)], "! END");

  if (tron)  fprintf(bug, "\n21  PAUSE:CLS") ;
  line__ubn = 21;
  getch(); clear(); refresh();;

  if (tron)  fprintf(bug, "\n23  FOR I=1 TO LINES") ;
  line__ubn = 23;
  I_f_ubn=1.0; *forP__ubn++=39; *returnP__ubn++=2;
  to__ubn[1]=(float)(LINES_f_ubn); step__ubn[1]=1.0; goto for__ubn1;
return2__ubn:
  I_f_ubn=I_f_ubn+step__ubn[1];
  if (step__ubn[1]>0 && I_f_ubn>to__ubn[1]) goto forgone__ubn;
  if (step__ubn[1]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[1]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[1]<0 && I_f_ubn<to__ubn[1]) goto forgone__ubn;
for__ubn1:
  if (tron)  fprintf(bug, "\n24  LINE$(I)=MID$(LINE$(I),2)") ;
  line__ubn = 24;
  let__ubn(LINE_s_ubn[index__ubn(I_f_ubn)], mid__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],2.0,0));
Al_ubn:
  if (tron)  fprintf(bug, "\n25 A IF RIGHT$(LINE$(I),1)=\" \"THEN LINE$(I)=LEFT$(LINE$(I),LEN(LINE$(I))-1):GOTO A") ;
  line__ubn = 25;
  if (strcmp(right__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],1.0), " ")==0) {let__ubn(LINE_s_ubn[index__ubn(I_f_ubn)], left__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],len__ubn(LINE_s_ubn[index__ubn(I_f_ubn)])-1.0)); goto Al_ubn;}
  if (tron)  fprintf(bug, "\n26  NEXT") ;
  line__ubn = 26;
  forvar__ubn=0; back__ubn=3; goto next__ubn;
return3__ubn:

OKl_ubn:
  if (tron)  fprintf(bug, "\n28 OK FOR I=1 TO LINES") ;
  line__ubn = 28;
  I_f_ubn=1.0; *forP__ubn++=39; *returnP__ubn++=4;
  to__ubn[2]=(float)(LINES_f_ubn); step__ubn[2]=1.0; goto for__ubn2;
return4__ubn:
  I_f_ubn=I_f_ubn+step__ubn[2];
  if (step__ubn[2]>0 && I_f_ubn>to__ubn[2]) goto forgone__ubn;
  if (step__ubn[2]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[2]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[2]<0 && I_f_ubn<to__ubn[2]) goto forgone__ubn;
for__ubn2:
  if (tron)  fprintf(bug, "\n29  PRINT LINE$(I);\"!\"") ;
  line__ubn = 29;
  printw(LINE_s_ubn[index__ubn(I_f_ubn)]);
  printw("!");
  printw("\n");
  refresh();
  if (tron)  fprintf(bug, "\n30  NEXT") ;
  line__ubn = 30;
  forvar__ubn=0; back__ubn=5; goto next__ubn;
return5__ubn:

  if (tron)  fprintf(bug, "\n32  PAUSE:CLS") ;
  line__ubn = 32;
  getch(); clear(); refresh();;

  if (tron)  fprintf(bug, "\n34  DIM BASE$(512)") ;
  line__ubn = 34;
  
  if (tron)  fprintf(bug, "\n35  EAST=0") ;
  line__ubn = 35;
  EAST_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n36  NORTH=1") ;
  line__ubn = 36;
  NORTH_f_ubn=1.0;
  if (tron)  fprintf(bug, "\n37  WEST=2") ;
  line__ubn = 37;
  WEST_f_ubn=2.0;
  if (tron)  fprintf(bug, "\n38  SOUTH=3") ;
  line__ubn = 38;
  SOUTH_f_ubn=3.0;
  if (tron)  fprintf(bug, "\n39  ROBOTS$(EAST)=\">\"") ;
  line__ubn = 39;
  let__ubn(ROBOTS_s_ubn[index__ubn(EAST_f_ubn)], ">");
  if (tron)  fprintf(bug, "\n40  ROBOTS$(NORTH)=\"A\"") ;
  line__ubn = 40;
  let__ubn(ROBOTS_s_ubn[index__ubn(NORTH_f_ubn)], "A");
  if (tron)  fprintf(bug, "\n41  ROBOTS$(WEST)=\"<\"") ;
  line__ubn = 41;
  let__ubn(ROBOTS_s_ubn[index__ubn(WEST_f_ubn)], "<");
  if (tron)  fprintf(bug, "\n42  ROBOTS$(SOUTH)=\"V\"") ;
  line__ubn = 42;
  let__ubn(ROBOTS_s_ubn[index__ubn(SOUTH_f_ubn)], "V");

  if (tron)  fprintf(bug, "\n44  DIM COMMANDS$(25)") ;
  line__ubn = 44;
  
  if (tron)  fprintf(bug, "\n45  DATA WALK, PICK UP, PUT DOWN, RETURN, END") ;
  line__ubn = 45;
  
  if (tron)  fprintf(bug, "\n46  DATA GOSUB, IF MARKED GOTO, IF ZERO GOTO, IF BLOCKED GOTO") ;
  line__ubn = 46;
  
  if (tron)  fprintf(bug, "\n47  DATA IF NOT MARKED GOTO, IF NOT ZERO GOTO, IF NOT BLOCKED GOTO, GOTO, /") ;
  line__ubn = 47;
  
  if (tron)  fprintf(bug, "\n48  COMMANDS=0") ;
  line__ubn = 48;
  COMMANDS_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n49  READ T$") ;
  line__ubn = 49;
  i__ubn=0; while ((T_s_ubn[i__ubn] = datav__ubn[datac__ubn][i__ubn]))  i__ubn++; datac__ubn++;
  if (tron)  fprintf(bug, "\n50  FOR I=0 TO 1 STEP 0") ;
  line__ubn = 50;
  I_f_ubn=0.0; *forP__ubn++=39; *returnP__ubn++=6;
  to__ubn[3]=(float)(1.0); step__ubn[3]=(float)(0.0); goto for__ubn3;
return6__ubn:
  I_f_ubn=I_f_ubn+step__ubn[3];
  if (step__ubn[3]>0 && I_f_ubn>to__ubn[3]) goto forgone__ubn;
  if (step__ubn[3]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[3]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[3]<0 && I_f_ubn<to__ubn[3]) goto forgone__ubn;
for__ubn3:
  if (tron)  fprintf(bug, "\n51  COMMANDS=COMMANDS+1") ;
  line__ubn = 51;
  COMMANDS_f_ubn=COMMANDS_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n52  COMMANDS$(COMMANDS)=T$") ;
  line__ubn = 52;
  let__ubn(COMMANDS_s_ubn[index__ubn(COMMANDS_f_ubn)], T_s_ubn);
  if (tron)  fprintf(bug, "\n53  READ T$") ;
  line__ubn = 53;
  i__ubn=0; while ((T_s_ubn[i__ubn] = datav__ubn[datac__ubn][i__ubn]))  i__ubn++; datac__ubn++;
  if (tron)  fprintf(bug, "\n54  PRINT T$") ;
  line__ubn = 54;
  printw(T_s_ubn);
  printw("\n");
  refresh();
  if (tron)  fprintf(bug, "\n55  IF T$=\"/\" THEN I=1") ;
  line__ubn = 55;
  if (strcmp(T_s_ubn, "/")==0) {I_f_ubn=1.0;}
  if (tron)  fprintf(bug, "\n56  NEXT") ;
  line__ubn = 56;
  forvar__ubn=0; back__ubn=7; goto next__ubn;
return7__ubn:

  if (tron)  fprintf(bug, "\n58  PAUSE:CLS") ;
  line__ubn = 58;
  getch(); clear(); refresh();;

  if (tron)  fprintf(bug, "\n60  DIM LABEL$(MAX), LABEL(MAX)") ;
  line__ubn = 60;
  
  if (tron)  fprintf(bug, "\n61  DIM COMMAND$(MAX), COMMAND(MAX)") ;
  line__ubn = 61;
  
  if (tron)  fprintf(bug, "\n62  DIM TARGET$(MAX), TARGET(MAX)") ;
  line__ubn = 62;
  
  if (tron)  fprintf(bug, "\n63  DIM SYMBOL$(MAX)") ;
  line__ubn = 63;
  
  if (tron)  fprintf(bug, "\n64  DIM ROBOTS$(4)") ;
  line__ubn = 64;
  
  if (tron)  fprintf(bug, "\n65  DIM SYMVAL(MAX)") ;
  line__ubn = 65;
  
  if (tron)  fprintf(bug, "\n66  DIM STACK(100)") ;
  line__ubn = 66;
  
  if (tron)  fprintf(bug, "\n67  FOR I=1 TO LINES") ;
  line__ubn = 67;
  I_f_ubn=1.0; *forP__ubn++=39; *returnP__ubn++=8;
  to__ubn[4]=(float)(LINES_f_ubn); step__ubn[4]=1.0; goto for__ubn4;
return8__ubn:
  I_f_ubn=I_f_ubn+step__ubn[4];
  if (step__ubn[4]>0 && I_f_ubn>to__ubn[4]) goto forgone__ubn;
  if (step__ubn[4]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[4]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[4]<0 && I_f_ubn<to__ubn[4]) goto forgone__ubn;
for__ubn4:
  if (tron)  fprintf(bug, "\n68  PRINT LINE$(I)") ;
  line__ubn = 68;
  printw(LINE_s_ubn[index__ubn(I_f_ubn)]);
  printw("\n");
  refresh();
  if (tron)  fprintf(bug, "\n69  IF LINE$(I)=\"\"THEN COMMAND(I)=14:GOTO SPLIT") ;
  line__ubn = 69;
  if (strcmp(LINE_s_ubn[index__ubn(I_f_ubn)], "")==0) {COMMAND_f_ubn[index__ubn(I_f_ubn)]=14.0; goto SPLITl_ubn;}
  if (tron)  fprintf(bug, "\n70  IF LEFT$(LINE$(I),1)=\" \"THEN L=1:GOTO NOLABEL") ;
  line__ubn = 70;
  if (strcmp(left__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],1.0), " ")==0) {L_f_ubn=1.0; goto NOLABELl_ubn;}
  if (tron)  fprintf(bug, "\n71  L=INSTR(LINE$(I),\" \")") ;
  line__ubn = 71;
  L_f_ubn=instr__ubn(1,LINE_s_ubn[index__ubn(I_f_ubn)]," ");
  if (tron)  fprintf(bug, "\n72  IF L=0 THEN LABEL$(I)=LINE$(I):COMMAND(I)=14:GOTO SPLIT") ;
  line__ubn = 72;
  if (fabs(fabs(L_f_ubn)-fabs(0.0))<sf__ubn) {let__ubn(LABEL_s_ubn[index__ubn(I_f_ubn)], LINE_s_ubn[index__ubn(I_f_ubn)]); COMMAND_f_ubn[index__ubn(I_f_ubn)]=14.0; goto SPLITl_ubn;}
  if (tron)  fprintf(bug, "\n73  LABEL$(I)=MID$(LINE$(I),1,L-1)") ;
  line__ubn = 73;
  let__ubn(LABEL_s_ubn[index__ubn(I_f_ubn)], mid__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],1.0,L_f_ubn-1.0));
NOLABELl_ubn:
  if (tron)  fprintf(bug, "\n74 NOLABEL FOR K=1 TO COMMANDS") ;
  line__ubn = 74;
  K_f_ubn=1.0; *forP__ubn++=46; *returnP__ubn++=9;
  to__ubn[5]=(float)(COMMANDS_f_ubn); step__ubn[5]=1.0; goto for__ubn5;
return9__ubn:
  K_f_ubn=K_f_ubn+step__ubn[5];
  if (step__ubn[5]>0 && K_f_ubn>to__ubn[5]) goto forgone__ubn;
  if (step__ubn[5]==0 && fabs(fabs(K_f_ubn)-fabs(to__ubn[5]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[5]<0 && K_f_ubn<to__ubn[5]) goto forgone__ubn;
for__ubn5:
  if (tron)  fprintf(bug, "\n75  J=INSTR(L+1, LINE$(I), COMMANDS$(K))") ;
  line__ubn = 75;
  J_f_ubn=instr__ubn(L_f_ubn+1.0,LINE_s_ubn[index__ubn(I_f_ubn)],COMMANDS_s_ubn[index__ubn(K_f_ubn)]);
  if (tron)  fprintf(bug, "\n76  IF J=0 THEN NEXT:PRINT\"BAD COMMAND IN LINE\";I:GOTO SPLIT") ;
  line__ubn = 76;
  if (fabs(fabs(J_f_ubn)-fabs(0.0))<sf__ubn) {forvar__ubn=0; back__ubn=10; goto next__ubn;
return10__ubn:
  printw("BAD COMMAND IN LINE");
  dend__ubn=I_f_ubn;
  if (fabs(fabs(round__ubn(dend__ubn))-fabs(dend__ubn))<.0000001)
    printw(" %d ", round__ubn(dend__ubn));
    printw("%s",float__ubn(phrase__ubn,I_f_ubn));
  printw("\n");
  refresh(); goto SPLITl_ubn;}
  if (tron)  fprintf(bug, "\n77  IF J<>L+1 THEN NEXT:PRINT\"BAD COMMAND IN LINE\";I:GOTO SPLIT") ;
  line__ubn = 77;
  if (fabs(fabs(J_f_ubn)-fabs(L_f_ubn+1.0))>sf__ubn) {forvar__ubn=0; back__ubn=11; goto next__ubn;
return11__ubn:
  printw("BAD COMMAND IN LINE");
  dend__ubn=I_f_ubn;
  if (fabs(fabs(round__ubn(dend__ubn))-fabs(dend__ubn))<.0000001)
    printw(" %d ", round__ubn(dend__ubn));
    printw("%s",float__ubn(phrase__ubn,I_f_ubn));
  printw("\n");
  refresh(); goto SPLITl_ubn;}
  if (tron)  fprintf(bug, "\n78  COMMAND$(I)=COMMANDS$(K)") ;
  line__ubn = 78;
  let__ubn(COMMAND_s_ubn[index__ubn(I_f_ubn)], COMMANDS_s_ubn[index__ubn(K_f_ubn)]);
  if (tron)  fprintf(bug, "\n79  COMMAND(I)=K") ;
  line__ubn = 79;
  COMMAND_f_ubn[index__ubn(I_f_ubn)]=K_f_ubn;
  if (tron)  fprintf(bug, "\n80  COMMANDER=K") ;
  line__ubn = 80;
  COMMANDER_f_ubn=K_f_ubn;
  if (tron)  fprintf(bug, "\n81  K=COMMANDS") ;
  line__ubn = 81;
  K_f_ubn=COMMANDS_f_ubn;
  if (tron)  fprintf(bug, "\n82  NEXT") ;
  line__ubn = 82;
  forvar__ubn=0; back__ubn=12; goto next__ubn;
return12__ubn:
  if (tron)  fprintf(bug, "\n83  IF COMMANDER<6 GOTO SPLIT") ;
  line__ubn = 83;
  if (COMMANDER_f_ubn<6.0) {goto SPLITl_ubn;}
  if (tron)  fprintf(bug, "\n84  IF COMMANDER=6 THEN J=J+6 ELSE J=INSTR(LINE$(I),\"GOTO\")+5") ;
  line__ubn = 84;
  if (fabs(fabs(COMMANDER_f_ubn)-fabs(6.0))<sf__ubn) {J_f_ubn=J_f_ubn+6.0;}
  else {J_f_ubn=instr__ubn(1,LINE_s_ubn[index__ubn(I_f_ubn)],"GOTO")+5.0;}
  if (tron)  fprintf(bug, "\n85  TARGET$(I)=MID$(LINE$(I),J)") ;
  line__ubn = 85;
  let__ubn(TARGET_s_ubn[index__ubn(I_f_ubn)], mid__ubn(LINE_s_ubn[index__ubn(I_f_ubn)],J_f_ubn,0));
SPLITl_ubn:
  if (tron)  fprintf(bug, "\n86 SPLIT NEXT") ;
  line__ubn = 86;
  forvar__ubn=0; back__ubn=13; goto next__ubn;
return13__ubn:

  if (tron)  fprintf(bug, "\n88  PAUSE:CLS") ;
  line__ubn = 88;
  getch(); clear(); refresh();;

  if (tron)  fprintf(bug, "\n90  FOR I=1 TO LINES") ;
  line__ubn = 90;
  I_f_ubn=1.0; *forP__ubn++=39; *returnP__ubn++=14;
  to__ubn[6]=(float)(LINES_f_ubn); step__ubn[6]=1.0; goto for__ubn6;
return14__ubn:
  I_f_ubn=I_f_ubn+step__ubn[6];
  if (step__ubn[6]>0 && I_f_ubn>to__ubn[6]) goto forgone__ubn;
  if (step__ubn[6]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[6]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[6]<0 && I_f_ubn<to__ubn[6]) goto forgone__ubn;
for__ubn6:
  if (tron)  fprintf(bug, "\n91  PRINT LABEL$(I);\",\";COMMAND$(I);\",\";TARGET$(I);\".\"") ;
  line__ubn = 91;
  printw(LABEL_s_ubn[index__ubn(I_f_ubn)]);
  printw(",");
  printw(COMMAND_s_ubn[index__ubn(I_f_ubn)]);
  printw(",");
  printw(TARGET_s_ubn[index__ubn(I_f_ubn)]);
  printw(".");
  printw("\n");
  refresh();
  if (tron)  fprintf(bug, "\n92  NEXT") ;
  line__ubn = 92;
  forvar__ubn=0; back__ubn=15; goto next__ubn;
return15__ubn:

  if (tron)  fprintf(bug, "\n94  PAUSE:CLS") ;
  line__ubn = 94;
  getch(); clear(); refresh();;

  if (tron)  fprintf(bug, "\n96  SYMBOLS=0") ;
  line__ubn = 96;
  SYMBOLS_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n97  FOR L=1 TO LINES") ;
  line__ubn = 97;
  L_f_ubn=1.0; *forP__ubn++=45; *returnP__ubn++=16;
  to__ubn[7]=(float)(LINES_f_ubn); step__ubn[7]=1.0; goto for__ubn7;
return16__ubn:
  L_f_ubn=L_f_ubn+step__ubn[7];
  if (step__ubn[7]>0 && L_f_ubn>to__ubn[7]) goto forgone__ubn;
  if (step__ubn[7]==0 && fabs(fabs(L_f_ubn)-fabs(to__ubn[7]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[7]<0 && L_f_ubn<to__ubn[7]) goto forgone__ubn;
for__ubn7:
  if (tron)  fprintf(bug, "\n98  SYMBOL=0") ;
  line__ubn = 98;
  SYMBOL_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n99  FOR J=1 TO SYMBOLS") ;
  line__ubn = 99;
  J_f_ubn=1.0; *forP__ubn++=47; *returnP__ubn++=17;
  to__ubn[8]=(float)(SYMBOLS_f_ubn); step__ubn[8]=1.0; goto for__ubn8;
return17__ubn:
  J_f_ubn=J_f_ubn+step__ubn[8];
  if (step__ubn[8]>0 && J_f_ubn>to__ubn[8]) goto forgone__ubn;
  if (step__ubn[8]==0 && fabs(fabs(J_f_ubn)-fabs(to__ubn[8]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[8]<0 && J_f_ubn<to__ubn[8]) goto forgone__ubn;
for__ubn8:
  if (tron)  fprintf(bug, "\n100  IF LABEL$(L)=SYMBOL$(J) THEN SYMBOL=J:J=SYMBOLS") ;
  line__ubn = 100;
  if (strcmp(LABEL_s_ubn[index__ubn(L_f_ubn)], SYMBOL_s_ubn[index__ubn(J_f_ubn)])==0) {SYMBOL_f_ubn=J_f_ubn; J_f_ubn=SYMBOLS_f_ubn;}
  if (tron)  fprintf(bug, "\n101  NEXT") ;
  line__ubn = 101;
  forvar__ubn=0; back__ubn=18; goto next__ubn;
return18__ubn:
  if (tron)  fprintf(bug, "\n102  IF SYMBOL>0 GOTO LABELFOUND") ;
  line__ubn = 102;
  if (SYMBOL_f_ubn>0.0) {goto LABELFOUNDl_ubn;}
  if (tron)  fprintf(bug, "\n103  SYMBOLS=SYMBOLS+1:") ;
  line__ubn = 103;
  SYMBOLS_f_ubn=SYMBOLS_f_ubn+1.0; ;
  if (tron)  fprintf(bug, "\n104  SYMBOL=SYMBOLS") ;
  line__ubn = 104;
  SYMBOL_f_ubn=SYMBOLS_f_ubn;
  if (tron)  fprintf(bug, "\n105  SYMBOL$(SYMBOL)=LABEL$(L)") ;
  line__ubn = 105;
  let__ubn(SYMBOL_s_ubn[index__ubn(SYMBOL_f_ubn)], LABEL_s_ubn[index__ubn(L_f_ubn)]);
LABELFOUNDl_ubn:
  if (tron)  fprintf(bug, "\n106 LABELFOUND LABEL(L)=SYMBOL") ;
  line__ubn = 106;
  LABEL_f_ubn[index__ubn(L_f_ubn)]=SYMBOL_f_ubn;
  if (tron)  fprintf(bug, "\n107  IF SYMVAL(SYMBOL)=0 THEN SYMVAL(SYMBOL)=L") ;
  line__ubn = 107;
  if (fabs(fabs(SYMVAL_f_ubn[index__ubn(SYMBOL_f_ubn)])-fabs(0.0))<sf__ubn) {SYMVAL_f_ubn[index__ubn(SYMBOL_f_ubn)]=L_f_ubn;}
  if (tron)  fprintf(bug, "\n108  SYMBOL=0") ;
  line__ubn = 108;
  SYMBOL_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n109  FOR J=1 TO SYMBOLS") ;
  line__ubn = 109;
  J_f_ubn=1.0; *forP__ubn++=47; *returnP__ubn++=19;
  to__ubn[9]=(float)(SYMBOLS_f_ubn); step__ubn[9]=1.0; goto for__ubn9;
return19__ubn:
  J_f_ubn=J_f_ubn+step__ubn[9];
  if (step__ubn[9]>0 && J_f_ubn>to__ubn[9]) goto forgone__ubn;
  if (step__ubn[9]==0 && fabs(fabs(J_f_ubn)-fabs(to__ubn[9]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[9]<0 && J_f_ubn<to__ubn[9]) goto forgone__ubn;
for__ubn9:
  if (tron)  fprintf(bug, "\n110  IF TARGET$(L)=SYMBOL$(J) THEN SYMBOL=J:J=SYMBOLS") ;
  line__ubn = 110;
  if (strcmp(TARGET_s_ubn[index__ubn(L_f_ubn)], SYMBOL_s_ubn[index__ubn(J_f_ubn)])==0) {SYMBOL_f_ubn=J_f_ubn; J_f_ubn=SYMBOLS_f_ubn;}
  if (tron)  fprintf(bug, "\n111  NEXT") ;
  line__ubn = 111;
  forvar__ubn=0; back__ubn=20; goto next__ubn;
return20__ubn:
  if (tron)  fprintf(bug, "\n112  IF SYMBOL>0 GOTO TARGETFOUND") ;
  line__ubn = 112;
  if (SYMBOL_f_ubn>0.0) {goto TARGETFOUNDl_ubn;}
  if (tron)  fprintf(bug, "\n113  SYMBOLS=SYMBOLS+1:") ;
  line__ubn = 113;
  SYMBOLS_f_ubn=SYMBOLS_f_ubn+1.0; ;
  if (tron)  fprintf(bug, "\n114  SYMBOL=SYMBOLS") ;
  line__ubn = 114;
  SYMBOL_f_ubn=SYMBOLS_f_ubn;
  if (tron)  fprintf(bug, "\n115  SYMBOL$(SYMBOL)=TARGET$(L)") ;
  line__ubn = 115;
  let__ubn(SYMBOL_s_ubn[index__ubn(SYMBOL_f_ubn)], TARGET_s_ubn[index__ubn(L_f_ubn)]);
TARGETFOUNDl_ubn:
  if (tron)  fprintf(bug, "\n116 TARGETFOUND TARGET(L)=SYMBOL") ;
  line__ubn = 116;
  TARGET_f_ubn[index__ubn(L_f_ubn)]=SYMBOL_f_ubn;
  if (tron)  fprintf(bug, "\n117  NEXT") ;
  line__ubn = 117;
  forvar__ubn=0; back__ubn=21; goto next__ubn;
return21__ubn:

  if (tron)  fprintf(bug, "\n119  DATA 4, 5") ;
  line__ubn = 119;
  
  if (tron)  fprintf(bug, "\n120  CLS") ;
  line__ubn = 120;
  clear(); refresh();;
  if (tron)  fprintf(bug, "\n121  FOR P=0 TO 319") ;
  line__ubn = 121;
  P_f_ubn=0.0; *forP__ubn++=51; *returnP__ubn++=22;
  to__ubn[10]=(float)(319.0); step__ubn[10]=1.0; goto for__ubn10;
return22__ubn:
  P_f_ubn=P_f_ubn+step__ubn[10];
  if (step__ubn[10]>0 && P_f_ubn>to__ubn[10]) goto forgone__ubn;
  if (step__ubn[10]==0 && fabs(fabs(P_f_ubn)-fabs(to__ubn[10]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[10]<0 && P_f_ubn<to__ubn[10]) goto forgone__ubn;
for__ubn10:
  if (tron)  fprintf(bug, "\n122  PRINT@P,\".\";") ;
  line__ubn = 122;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(".");
  refresh();
  if (tron)  fprintf(bug, "\n123  BASE$(P)=\".\"") ;
  line__ubn = 123;
  let__ubn(BASE_s_ubn[index__ubn(P_f_ubn)], ".");
  if (tron)  fprintf(bug, "\n124  NEXT") ;
  line__ubn = 124;
  forvar__ubn=0; back__ubn=23; goto next__ubn;
return23__ubn:

  if (tron)  fprintf(bug, "\n126  FOR P=8 TO 16 STEP 8") ;
  line__ubn = 126;
  P_f_ubn=8.0; *forP__ubn++=51; *returnP__ubn++=24;
  to__ubn[11]=(float)(16.0); step__ubn[11]=(float)(8.0); goto for__ubn11;
return24__ubn:
  P_f_ubn=P_f_ubn+step__ubn[11];
  if (step__ubn[11]>0 && P_f_ubn>to__ubn[11]) goto forgone__ubn;
  if (step__ubn[11]==0 && fabs(fabs(P_f_ubn)-fabs(to__ubn[11]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[11]<0 && P_f_ubn<to__ubn[11]) goto forgone__ubn;
for__ubn11:
  if (tron)  fprintf(bug, "\n127  READ SIZE$") ;
  line__ubn = 127;
  i__ubn=0; while ((SIZE_s_ubn[i__ubn] = datav__ubn[datac__ubn][i__ubn]))  i__ubn++; datac__ubn++;
  if (tron)  fprintf(bug, "\n128  FOR I=1 TO LEN(SIZE$)") ;
  line__ubn = 128;
  I_f_ubn=1.0; *forP__ubn++=39; *returnP__ubn++=25;
  to__ubn[12]=(float)(len__ubn(SIZE_s_ubn)); step__ubn[12]=1.0; goto for__ubn12;
return25__ubn:
  I_f_ubn=I_f_ubn+step__ubn[12];
  if (step__ubn[12]>0 && I_f_ubn>to__ubn[12]) goto forgone__ubn;
  if (step__ubn[12]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[12]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[12]<0 && I_f_ubn<to__ubn[12]) goto forgone__ubn;
for__ubn12:
  if (tron)  fprintf(bug, "\n129  PRINT@P+I,MID$(SIZE$,I,1);") ;
  line__ubn = 129;
  P__ubn=.2+P_f_ubn+I_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(mid__ubn(SIZE_s_ubn,I_f_ubn,1.0));
  refresh();
  if (tron)  fprintf(bug, "\n130  BASE$(P+I)=MID$(SIZE$,I,1)") ;
  line__ubn = 130;
  let__ubn(BASE_s_ubn[index__ubn(P_f_ubn+I_f_ubn)], mid__ubn(SIZE_s_ubn,I_f_ubn,1.0));
  if (tron)  fprintf(bug, "\n131  NEXT") ;
  line__ubn = 131;
  forvar__ubn=0; back__ubn=26; goto next__ubn;
return26__ubn:
  if (tron)  fprintf(bug, "\n132  NEXT") ;
  line__ubn = 132;
  forvar__ubn=0; back__ubn=27; goto next__ubn;
return27__ubn:
  if (tron)  fprintf(bug, "\n133  P=0") ;
  line__ubn = 133;
  P_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n134  UNDER$=BASE$(P)") ;
  line__ubn = 134;
  let__ubn(UNDER_s_ubn, BASE_s_ubn[index__ubn(P_f_ubn)]);
  if (tron)  fprintf(bug, "\n135  DIRECTION=EAST") ;
  line__ubn = 135;
  DIRECTION_f_ubn=EAST_f_ubn;
  if (tron)  fprintf(bug, "\n136  ROBOT$=ROBOTS$(DIRECTION)") ;
  line__ubn = 136;
  let__ubn(ROBOT_s_ubn, ROBOTS_s_ubn[index__ubn(DIRECTION_f_ubn)]);
  if (tron)  fprintf(bug, "\n137  PRINT@P,ROBOT$;") ;
  line__ubn = 137;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(ROBOT_s_ubn);
  refresh();

  if (tron)  fprintf(bug, "\n139  PAUSE") ;
  line__ubn = 139;
  getch();

  if (tron)  fprintf(bug, "\n141  TOP=0") ;
  line__ubn = 141;
  TOP_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n142  L=0") ;
  line__ubn = 142;
  L_f_ubn=0.0;
  if (tron)  fprintf(bug, "\n143  FOR I=0 TO 1 STEP 0") ;
  line__ubn = 143;
  I_f_ubn=0.0; *forP__ubn++=39; *returnP__ubn++=28;
  to__ubn[13]=(float)(1.0); step__ubn[13]=(float)(0.0); goto for__ubn13;
return28__ubn:
  I_f_ubn=I_f_ubn+step__ubn[13];
  if (step__ubn[13]>0 && I_f_ubn>to__ubn[13]) goto forgone__ubn;
  if (step__ubn[13]==0 && fabs(fabs(I_f_ubn)-fabs(to__ubn[13]))<sf__ubn) goto forgone__ubn;
  if (step__ubn[13]<0 && I_f_ubn<to__ubn[13]) goto forgone__ubn;
for__ubn13:
  if (tron)  fprintf(bug, "\n144  L=L+1") ;
  line__ubn = 144;
  L_f_ubn=L_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n145  ON COMMAND(L) GOTO WALK,UP,DOWN,return,end,gosub,MARKED,ZERO,BLOCKED") ;
  line__ubn = 145;
  switch(index__ubn(COMMAND_f_ubn[index__ubn(L_f_ubn)])) {
    case 1: goto WALKl_ubn;
    case 2: goto UPl_ubn;
    case 3: goto DOWNl_ubn;
    case 4: goto returnl_ubn;
    case 5: goto endl_ubn;
    case 6: goto gosubl_ubn;
    case 7: goto MARKEDl_ubn;
    case 8: goto ZEROl_ubn;
    case 9: goto BLOCKEDl_ubn;
  }
;
  if (tron)  fprintf(bug, "\n146  ON COMMAND(L)-9 GOTO NOTMARKED,NOTZERO,NOTBLOCKED,goto,SKIP") ;
  line__ubn = 146;
  switch(index__ubn(COMMAND_f_ubn[index__ubn(L_f_ubn)]-9.0)) {
    case 1: goto NOTMARKEDl_ubn;
    case 2: goto NOTZEROl_ubn;
    case 3: goto NOTBLOCKEDl_ubn;
    case 4: goto gotol_ubn;
    case 5: goto SKIPl_ubn;
  }
;
  if (tron)  fprintf(bug, "\n147  PRINT@320,\"INTERNAL ERROR IN\";L") ;
  line__ubn = 147;
  P__ubn=.2+320.0;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw("INTERNAL ERROR IN");
  dend__ubn=L_f_ubn;
  if (fabs(fabs(round__ubn(dend__ubn))-fabs(dend__ubn))<.0000001)
    printw(" %d ", round__ubn(dend__ubn));
    printw("%s",float__ubn(phrase__ubn,L_f_ubn));
  printw("\n");
  refresh();
SKIPl_ubn:
  if (tron)  fprintf(bug, "\n148 SKIP NEXT") ;
  line__ubn = 148;
  forvar__ubn=0; back__ubn=29; goto next__ubn;
return29__ubn:
WALKl_ubn:
  if (tron)  fprintf(bug, "\n149 WALK PRINT@P,UNDER$;") ;
  line__ubn = 149;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(UNDER_s_ubn);
  refresh();
  if (tron)  fprintf(bug, "\n150  P=P+1") ;
  line__ubn = 150;
  P_f_ubn=P_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n151  UNDER$=BASE$(P)") ;
  line__ubn = 151;
  let__ubn(UNDER_s_ubn, BASE_s_ubn[index__ubn(P_f_ubn)]);
  if (tron)  fprintf(bug, "\n152  PRINT@P,ROBOT$;") ;
  line__ubn = 152;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(ROBOT_s_ubn);
  refresh();
  if (tron)  fprintf(bug, "\n153  NEXT") ;
  line__ubn = 153;
  forvar__ubn=0; back__ubn=30; goto next__ubn;
return30__ubn:
UPl_ubn:
  if (tron)  fprintf(bug, "\n154 UP UNDER$=CHR$(ASC(UNDER$)-1):") ;
  line__ubn = 154;
  let__ubn(UNDER_s_ubn, chr__ubn(asc__ubn(UNDER_s_ubn)-1.0)); ;
  if (tron)  fprintf(bug, "\n155  IF UNDER$=\"0\" THEN UNDER$=\".\"") ;
  line__ubn = 155;
  if (strcmp(UNDER_s_ubn, "0")==0) {let__ubn(UNDER_s_ubn, ".");}
  if (tron)  fprintf(bug, "\n156  PRINT@P,UNDER$;") ;
  line__ubn = 156;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(UNDER_s_ubn);
  refresh();
  if (tron)  fprintf(bug, "\n157  NEXT") ;
  line__ubn = 157;
  forvar__ubn=0; back__ubn=31; goto next__ubn;
return31__ubn:
DOWNl_ubn:
  if (tron)  fprintf(bug, "\n158 DOWN UNDER$=CHR$(ASC(UNDER$)+1)") ;
  line__ubn = 158;
  let__ubn(UNDER_s_ubn, chr__ubn(asc__ubn(UNDER_s_ubn)+1.0));
  if (tron)  fprintf(bug, "\n159  IF UNDER$=CHR$(ASC(\".\")+1) THEN UNDER$=\"1\"") ;
  line__ubn = 159;
  if (strcmp(UNDER_s_ubn, chr__ubn(asc__ubn(".")+1.0))==0) {let__ubn(UNDER_s_ubn, "1");}
  if (tron)  fprintf(bug, "\n160  PRINT@P,UNDER$;") ;
  line__ubn = 160;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(UNDER_s_ubn);
  refresh();
  if (tron)  fprintf(bug, "\n161  NEXT") ;
  line__ubn = 161;
  forvar__ubn=0; back__ubn=32; goto next__ubn;
return32__ubn:
returnl_ubn:
  if (tron)  fprintf(bug, "\n162 return IF TOP=0 THEN PRINT@P,UNDER$;:PRINT@320:END") ;
  line__ubn = 162;
  if (fabs(fabs(TOP_f_ubn)-fabs(0.0))<sf__ubn) {P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(UNDER_s_ubn);
  refresh(); P__ubn=.2+320.0;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  ;
  refresh(); refresh(); getch();
  for(i__ubn=0; i__ubn<26; i__ubn++) printw("\n");
  refresh(); endwin(); exit(0);}
  if (tron)  fprintf(bug, "\n163  TOP=TOP-1") ;
  line__ubn = 163;
  TOP_f_ubn=TOP_f_ubn-1.0;
  if (tron)  fprintf(bug, "\n164  L=STACK(TOP)") ;
  line__ubn = 164;
  L_f_ubn=STACK_f_ubn[index__ubn(TOP_f_ubn)];
  if (tron)  fprintf(bug, "\n165  NEXT") ;
  line__ubn = 165;
  forvar__ubn=0; back__ubn=33; goto next__ubn;
return33__ubn:
endl_ubn:
  if (tron)  fprintf(bug, "\n166 end PRINT@P,UNDER$;") ;
  line__ubn = 166;
  P__ubn=.2+P_f_ubn;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  printw(UNDER_s_ubn);
  refresh();
  if (tron)  fprintf(bug, "\n167  PRINT@320") ;
  line__ubn = 167;
  P__ubn=.2+320.0;
  move(P__ubn/32, P__ubn-P__ubn/32*32);
  ;
  refresh();
  if (tron)  fprintf(bug, "\n168  PAUSE:CLS:END") ;
  line__ubn = 168;
  getch(); clear(); refresh();; refresh(); getch();
  for(i__ubn=0; i__ubn<26; i__ubn++) printw("\n");
  refresh(); endwin(); exit(0);
gotol_ubn:
  if (tron)  fprintf(bug, "\n169 goto L=SYMVAL(TARGET(L))-1") ;
  line__ubn = 169;
  L_f_ubn=SYMVAL_f_ubn[index__ubn(TARGET_f_ubn[index__ubn(L_f_ubn)])]-1.0;
  if (tron)  fprintf(bug, "\n170  NEXT") ;
  line__ubn = 170;
  forvar__ubn=0; back__ubn=34; goto next__ubn;
return34__ubn:
gosubl_ubn:
  if (tron)  fprintf(bug, "\n171 gosub STACK(TOP)=L") ;
  line__ubn = 171;
  STACK_f_ubn[index__ubn(TOP_f_ubn)]=L_f_ubn;
  if (tron)  fprintf(bug, "\n172  TOP=TOP+1") ;
  line__ubn = 172;
  TOP_f_ubn=TOP_f_ubn+1.0;
  if (tron)  fprintf(bug, "\n173  GOTO goto") ;
  line__ubn = 173;
  goto gotol_ubn;
MARKEDl_ubn:
  if (tron)  fprintf(bug, "\n174 MARKED IF UNDER$<>\".\" GOTO goto") ;
  line__ubn = 174;
  if (strcmp(UNDER_s_ubn, ".")!=0) {goto gotol_ubn;}
  if (tron)  fprintf(bug, "\n175  NEXT") ;
  line__ubn = 175;
  forvar__ubn=0; back__ubn=35; goto next__ubn;
return35__ubn:
ZEROl_ubn:
  if (tron)  fprintf(bug, "\n176 ZERO IF UNDER$=\"0\" GOTO goto") ;
  line__ubn = 176;
  if (strcmp(UNDER_s_ubn, "0")==0) {goto gotol_ubn;}
  if (tron)  fprintf(bug, "\n177  NEXT") ;
  line__ubn = 177;
  forvar__ubn=0; back__ubn=36; goto next__ubn;
return36__ubn:
BLOCKEDl_ubn:
  if (tron)  fprintf(bug, "\n178 BLOCKED NEXT") ;
  line__ubn = 178;
  forvar__ubn=0; back__ubn=37; goto next__ubn;
return37__ubn:
NOTMARKEDl_ubn:
  if (tron)  fprintf(bug, "\n179 NOTMARKED IF UNDER$=\".\" GOTO goto") ;
  line__ubn = 179;
  if (strcmp(UNDER_s_ubn, ".")==0) {goto gotol_ubn;}
  if (tron)  fprintf(bug, "\n180  NEXT") ;
  line__ubn = 180;
  forvar__ubn=0; back__ubn=38; goto next__ubn;
return38__ubn:
NOTZEROl_ubn:
  if (tron)  fprintf(bug, "\n181 NOTZERO IF UNDER$<>\"0\" GOTO goto") ;
  line__ubn = 181;
  if (strcmp(UNDER_s_ubn, "0")!=0) {goto gotol_ubn;}
  if (tron)  fprintf(bug, "\n182  NEXT") ;
  line__ubn = 182;
  forvar__ubn=0; back__ubn=39; goto next__ubn;
return39__ubn:
NOTBLOCKEDl_ubn:
  if (tron)  fprintf(bug, "\n183 NOTBLOCKED NEXT") ;
  line__ubn = 183;
  forvar__ubn=0; back__ubn=40; goto next__ubn;
return40__ubn:

next__ubn:
  while (1) {
    if (*(forP__ubn-1)==forvar__ubn) break;
    if (*(forP__ubn-1)<0)
    error__ubn("next without for", line__ubn);
    if (forvar__ubn==0)  break;
    forP__ubn--;
    returnP__ubn--;
    if (forP__ubn==fora__ubn)
    error__ubn("next without for", line__ubn);
  }
  switcher__ubn = *(returnP__ubn-1);
  goto switching__ubn;

forgone__ubn:
  forP__ubn--; returnP__ubn--; switcher__ubn=back__ubn; goto switching__ubn;

returns__ubn:
  if (forP__ubn<=fora__ubn) {
    for (tempP__ubn=returnP__ubn; tempP__ubn<returnP__ubn+20; tempP__ubn++)
      printf("\n%d", *tempP__ubn);
    error__ubn("return without gosub", line__ubn);
  }
  while (forP__ubn>fora__ubn) {
    forP__ubn--;
    returnP__ubn--;
    if (*forP__ubn<0) break;
  }
  if(*forP__ubn>=0) {
    for (tempP__ubn=forP__ubn; tempP__ubn<forP__ubn+20; tempP__ubn++)
      printf("%d\n", *tempP__ubn);
    error__ubn("return without gosub", line__ubn);
  }
  switcher__ubn = *returnP__ubn;
  goto switching__ubn;

switching__ubn:
  switch(switcher__ubn) {
    case 0: goto return0__ubn;
    case 1: goto return1__ubn;
    case 2: goto return2__ubn;
    case 3: goto return3__ubn;
    case 4: goto return4__ubn;
    case 5: goto return5__ubn;
    case 6: goto return6__ubn;
    case 7: goto return7__ubn;
    case 8: goto return8__ubn;
    case 9: goto return9__ubn;
    case 10: goto return10__ubn;
    case 11: goto return11__ubn;
    case 12: goto return12__ubn;
    case 13: goto return13__ubn;
    case 14: goto return14__ubn;
    case 15: goto return15__ubn;
    case 16: goto return16__ubn;
    case 17: goto return17__ubn;
    case 18: goto return18__ubn;
    case 19: goto return19__ubn;
    case 20: goto return20__ubn;
    case 21: goto return21__ubn;
    case 22: goto return22__ubn;
    case 23: goto return23__ubn;
    case 24: goto return24__ubn;
    case 25: goto return25__ubn;
    case 26: goto return26__ubn;
    case 27: goto return27__ubn;
    case 28: goto return28__ubn;
    case 29: goto return29__ubn;
    case 30: goto return30__ubn;
    case 31: goto return31__ubn;
    case 32: goto return32__ubn;
    case 33: goto return33__ubn;
    case 34: goto return34__ubn;
    case 35: goto return35__ubn;
    case 36: goto return36__ubn;
    case 37: goto return37__ubn;
    case 38: goto return38__ubn;
    case 39: goto return39__ubn;
    case 40: goto return40__ubn;
  }
  refresh();
  getch();
  endwin();
  exit(0);
}
